/********************************************************************************
  mpeg2/syntax/tsinput.hh

  purpose:
    Creates an input stream containing the payload of a transport stream.

  notes:

  to do:

  author(s):
   - Dirk Farin, dirk.farin@gmx.de

  modifications:
   17/Mar/2002 - Dirk Farin - first implementation
 ********************************************************************************
    Copyright (C) 2002  Dirk Farin

    This program is distributed under GNU Public License (GPL) as
    outlined in the COPYING file that comes with the source distribution.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ********************************************************************************/

#ifndef LIBVIDEOCODING_MPEG2_SYNTAX_TSINPUT_HH
#define LIBVIDEOCODING_MPEG2_SYNTAX_TSINPUT_HH

#include <libvideocoding/fileio/inputstream.hh>
#include <libvideocoding/mpeg2/syntax/system.hh>

namespace videocoding {
  using namespace videogfx;

  class InputStream_TS : public InputStream
  {
  public:
    InputStream_TS();
    ~InputStream_TS();

    void SetInputStream(InputStream& istr) { d_istr = &istr; }

    bool   IsEOF() const;
  
    bool   IsFiniteStream() const { return false; } // return d_istr->IsFiniteStream(); }
    uint64 AskStreamLength() const { return 0; }
  
    bool   MaySeek() const { return false; }
    uint64 AskPosition() const { return 0; }
    uint64 SetPosition(uint64) { return 0; }

  private:
    uint32 MyFillBuffer(uint8* mem,uint32 maxlen);

  private:
    InputStream* d_istr;

    MP2_Transport_Packet d_current;
    bool d_packet_valid;
    int d_idx;

    bool ReadNextPacket();  // false if no more packets
  };

}

#endif
